#include <iostream>
#include <vector>
#include <string>
#include <algorithm> 
#include <cstring>
#include <cmath>
#include <climits>
#include <thread>
#include <chrono>
#include <numeric>
#include <iomanip>
#include <fstream>
#include <random>

#define ll long long
#define ull unsigned long long

using namespace std;

void DFS(vector<vector<int>> edges, vector<int>& stamina, vector<bool>& visited, int v) {
	visited[v] = true;

	for (int conn : edges[v]) {
		if (!visited[conn]) DFS(edges, stamina, visited, conn);
		if (stamina[v] < stamina[conn] - 1) stamina[v] = stamina[conn] - 1;
	}
}

int main() {
	int n, m, k, tempA, tempB; cin >> n >> m >> k;
	vector<vector<int>> edges(n);
	vector<int> stamina(n, -1);

	for (int i = 0; i < m; i++) {
		cin >> tempA >> tempB;
		edges[tempA - 1].push_back(tempB - 1);
		edges[tempB - 1].push_back(tempA - 1);
	}
	for (int i = 0; i < k; i++) {
		cin >> tempA >> tempB;
		stamina[tempA - 1] = tempB;
	}

	vector<bool> visited(n);
	for (int i = 0; i < n; i++) {
		if (!visited[i]) DFS(edges, stamina, visited, i);
	}

	vector<int> secured;
	for (int i = 0; i < n; i++) {
		if (stamina[i] >= 0) secured.push_back(i + 1);
	}

	cout << secured.size() << endl;
	for (int i : secured) cout << i << " ";
}