#include <iostream>
#include <vector>
#include <string>
#include <algorithm> 
#include <cstring>
#include <cmath>
#include <climits>
#include <thread>
#include <chrono>
#include <numeric>
#include <iomanip>
#include <fstream>
#include <random>

#define ll long long
#define ull unsigned long long

using namespace std;

vector<pair<float, float>> rotatePoints(vector<pair<int, int>> points, float angle) {
	vector<pair<float, float>> res(points.size());
	float cosA = cos(angle), sinA = sin(angle);
	for (int i = 0; i < points.size(); i++) {
		res[i].first = points[i].first * cosA - points[i].second * sinA;
		res[i].second = points[i].first * sinA + points[i].second * cosA;
	}
	return res;
}

float getPathLength(vector<pair<float, float>> points) {
	float res = 0;
	for (int i = 1; i < points.size(); i++) {
		res += abs(points[i].first - points[i - 1].first) + abs(points[i].second - points[i - 1].second);
	}
	return res;
}

int main() {
	int n; cin >> n;
	vector<pair<int, int>> points(n);
	for (int i = 0; i < n; i++) cin >> points[i].first >> points[i].second;
	
	float min = INT_MAX;
	for (float i = 0; i <= 90; i += 0.01f) {
		float path = getPathLength(rotatePoints(points, i));
		if (min > path) min = path;
	}
	cout << min;
}